import { Injectable, ɵɵdefineInjectable, Component, NgModule } from '@angular/core';
import { firestore } from 'firebase/app';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/service/ngx-timestamp-date.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTimestampDateService {
    constructor() { }
    /**
     * @param {?} timestamp
     * @return {?}
     */
    timestampToDate(timestamp) {
        /** @type {?} */
        const date = (/** @type {?} */ (timestamp));
        return date.toDate();
    }
    /**
     * @param {?} date
     * @return {?}
     */
    dateToTimestamp(date) {
        return firestore.Timestamp.fromDate(date);
    }
    /**
     * @template T
     * @param {?} data
     * @return {?}
     */
    parseTimestampToDate(data) {
        /** @type {?} */
        let doc = data;
        if (doc) {
            if (Array.isArray(doc)) {
                doc = doc.map(this.checkPropertyValue.bind(this));
            }
            if (doc.constructor.name === 'Object') {
                Object.keys(doc).forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                key => {
                    doc[key] = this.checkPropertyValue(doc[key]);
                }));
            }
        }
        return doc;
    }
    /**
     * @private
     * @param {?} element
     * @return {?}
     */
    checkPropertyValue(element) {
        if (element) {
            if ((element._seconds >= 0 || element.seconds >= 0) &&
                (element._nanoseconds >= 0 || element.nanoseconds >= 0)) {
                element = new Date((element._seconds || element.seconds) * 1000);
            }
            else {
                element = this.parseTimestampToDate(element);
            }
        }
        return element;
    }
}
NgxTimestampDateService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxTimestampDateService.ctorParameters = () => [];
/** @nocollapse */ NgxTimestampDateService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxTimestampDateService_Factory() { return new NgxTimestampDateService(); }, token: NgxTimestampDateService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/ngx-timestamp-date.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTimestampDateComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
NgxTimestampDateComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-ngx-timestamp-date',
                template: `
    <p>
      ngx-timestamp-date works!
    </p>
  `
            }] }
];
/** @nocollapse */
NgxTimestampDateComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-timestamp-date.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTimestampDateModule {
}
NgxTimestampDateModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NgxTimestampDateComponent
                ],
                imports: [],
                exports: [
                    NgxTimestampDateComponent
                ],
                providers: [
                    NgxTimestampDateService
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-timestamp-date.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxTimestampDateComponent, NgxTimestampDateModule, NgxTimestampDateService };
//# sourceMappingURL=ngx-timestamp-date.js.map
